<?php
declare(strict_types=1);

namespace Catequil\Webshop\Hydrator;

use Catequil\Core\Hydrator\DefaultHydrator;
use Catequil\Webshop\Model\WebshopInterface;
use Laminas\Hydrator\Strategy\ClosureStrategy;
use Laminas\Hydrator\Strategy\DateTimeFormatterStrategy;

/**
 * Class WebshopOrderHydrator
 *
 * @package Catequil\Webshop\Hydrator
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-webshop
 */
final class WebshopOrderHydrator extends DefaultHydrator
{
    public function __construct()
    {
        parent::__construct();

        $this->addStrategy('webshop', new ClosureStrategy(
            fn (WebshopInterface $webshop) => $webshop->getDomain(),
        ));
        $this->addStrategy('updatedAt', new DateTimeFormatterStrategy());
    }
}